diff --git a/app/src/main/java/jp/deadend/noname/skk/QwertyKeyboardView.kt b/app/src/main/java/jp/deadend/noname/skk/QwertyKeyboardView.kt
index 43084bc..01968d1 100644
--- a/app/src/main/java/jp/deadend/noname/skk/QwertyKeyboardView.kt
+++ b/app/src/main/java/jp/deadend/noname/skk/QwertyKeyboardView.kt
@@ -8,15 +8,18 @@ import java.io.BufferedReader
 import java.io.IOException
 import java.io.InputStream
 import java.io.InputStreamReader
+import jp.deadend.noname.skk.engine.SKKCyrillicState
 
 class QwertyKeyboardView : KeyboardView, KeyboardView.OnKeyboardActionListener {
     private lateinit var mService: SKKService
     private val mInputHistory = StringBuilder() // suggestion用に入力の履歴を覚えておく
     private val mList = mutableListOf<String>() // suggestion用の単語リスト(頻度順)
+    private val mCyrillicList = mutableListOf<String>() // cyrillic suggestion用の単語リスト(頻度順)
 
     private val mLatinKeyboard = Keyboard(context, R.xml.qwerty)
     private val mSymbolsKeyboard = Keyboard(context, R.xml.symbols)
     private val mSymbolsShiftedKeyboard = Keyboard(context, R.xml.symbols_shift)
+    private val mCyrillicKeyboard = Keyboard(context, R.xml.cyrillic)
 
     private var mFlickSensitivitySquared = 100
     private var mFlickStartX = -1f
@@ -53,6 +56,18 @@ class QwertyKeyboardView : KeyboardView, KeyboardView.OnKeyboardActionListener {
         }
     }
 
+    @Throws(IOException::class)
+    internal fun loadCyrillicFrequencyList(inputStream: InputStream) {
+        mCyrillicList.clear()
+        BufferedReader(InputStreamReader(inputStream)).use { bufferedReader ->
+            bufferedReader.forEachLine { line ->
+                if (line.length > 3) { mCyrillicList.add(line) }
+                // 短い単語はsuggestionに入れない
+                // 読んだ順に入れるだけなので、ファイルの内容自体が頻度順に並んでいることが前提
+            }
+        }
+    }
+
     fun setService(listener: SKKService) {
         mService = listener
     }
@@ -61,6 +76,8 @@ class QwertyKeyboardView : KeyboardView, KeyboardView.OnKeyboardActionListener {
         mFlickSensitivitySquared = sensitivity * sensitivity
     }
 
+    fun setCyrillicMode(isCyrillic: Boolean) { keyboard = if (isCyrillic) mCyrillicKeyboard else mLatinKeyboard }
+
     override fun onLongPress(key: Keyboard.Key): Boolean {
         if (key.codes[0] == KEYCODE_QWERTY_ENTER) {
             mService.keyDownUp(KeyEvent.KEYCODE_SEARCH)
@@ -121,16 +138,25 @@ class QwertyKeyboardView : KeyboardView, KeyboardView.OnKeyboardActionListener {
                 }
             }
             KEYCODE_QWERTY_ENTER -> if (!mService.handleEnter()) mService.pressEnter()
-            KEYCODE_QWERTY_TOJP -> mService.handleKanaKey()
+            KEYCODE_QWERTY_TOJP -> {
+                if (keyboard === mCyrillicKeyboard) { keyboard = mLatinKeyboard }
+                mService.handleKanaKey()
+            }
             KEYCODE_QWERTY_TOSYM -> keyboard = mSymbolsKeyboard
-            KEYCODE_QWERTY_TOLATIN -> keyboard = mLatinKeyboard
+            KEYCODE_QWERTY_TOLATIN -> {
+                if (keyboard === mCyrillicKeyboard) {
+                    mService.processKey(SKKCyrillicState.KEYCODE_TOGGLE_CYRILLIC)
+                }
+                keyboard = mLatinKeyboard
+            }
+
             else -> {
-                val code = if (keyboard === mLatinKeyboard && (isShifted xor mFlicked)) {
+                val code = if ((keyboard === mLatinKeyboard || keyboard === mCyrillicKeyboard) && (isShifted xor mFlicked)) {
                     Character.toUpperCase(primaryCode)
                 } else {
                     primaryCode
                 }
-                if (keyboard == mLatinKeyboard && isShifted) { isShifted = false }
+                if ((keyboard == mLatinKeyboard || keyboard == mCyrillicKeyboard) && isShifted) { isShifted = false }
 
                 mService.commitTextSKK(code.toChar().toString())
                 if (code.toChar().isLetter()) {
@@ -152,7 +178,11 @@ class QwertyKeyboardView : KeyboardView, KeyboardView.OnKeyboardActionListener {
 
     private fun updateAsciiSuggestions(str: String) {
         mService.setCandidates(
-            mList.filter { it.startsWith(str) }.take(20)
+            if (keyboard === mCyrillicKeyboard) {
+                mCyrillicList.filter { it.startsWith(str) }.take(20)
+            } else {
+                mList.filter { it.startsWith(str) }.take(20)
+            }
         )
     }
 
@@ -173,7 +203,10 @@ class QwertyKeyboardView : KeyboardView, KeyboardView.OnKeyboardActionListener {
 
     override fun swipeRight() {}
 
-    override fun swipeLeft() {}
+    override fun swipeLeft() {
+        keyboard = if (keyboard === mCyrillicKeyboard) mLatinKeyboard else mCyrillicKeyboard
+        mService.processKey(SKKCyrillicState.KEYCODE_TOGGLE_CYRILLIC)
+    }
 
     override fun swipeDown() {}
 
diff --git a/app/src/main/java/jp/deadend/noname/skk/SKKPrefs.kt b/app/src/main/java/jp/deadend/noname/skk/SKKPrefs.kt
index 584fecc..573176a 100644
--- a/app/src/main/java/jp/deadend/noname/skk/SKKPrefs.kt
+++ b/app/src/main/java/jp/deadend/noname/skk/SKKPrefs.kt
@@ -31,6 +31,10 @@ class SKKPrefs(context: Context) {
         get() = prefs.getInt(res.getString(R.string.prefkey_cancel_key), 564) // 564はCtrl+g
         set(value) = prefs.edit().putInt(res.getString(R.string.prefkey_cancel_key), value).apply()
 
+    var cyrillicKey: Int
+        get() = prefs.getInt(res.getString(R.string.prefkey_cyrillic_key), 0)
+        set(value) = prefs.edit().putInt(res.getString(R.string.prefkey_cyrillic_key), value).apply()
+
     var toggleKanaKey: Boolean
         get() = prefs.getBoolean(res.getString(R.string.prefkey_toggle_kana_key), true)
         set(value) = prefs.edit().putBoolean(res.getString(R.string.prefkey_toggle_kana_key), value).apply()
diff --git a/app/src/main/java/jp/deadend/noname/skk/SKKService.kt b/app/src/main/java/jp/deadend/noname/skk/SKKService.kt
index f4f747b..127ec99 100644
--- a/app/src/main/java/jp/deadend/noname/skk/SKKService.kt
+++ b/app/src/main/java/jp/deadend/noname/skk/SKKService.kt
@@ -301,6 +301,7 @@ class SKKService : InputMethodService() {
         abbrev.backgroundAlpha = 255 * alpha / 100
 
         qwerty.loadFrequencyList(resources.assets.open(FREQUENCY_LIST_FILE))
+        qwerty.loadCyrillicFrequencyList(resources.assets.open(CYRILLIC_FREQUENCY_LIST_FILE))
     }
 
     private fun checkUseSoftKeyboard(): Boolean {
@@ -572,6 +573,11 @@ class SKKService : InputMethodService() {
             return true
         }
 
+        if ((engineState === SKKHiraganaState || engineState === SKKKatakanaState || engineState === SKKASCIIState || engineState === SKKZenkakuState || engineState === SKKCyrillicState) && encodedKey == skkPrefs.cyrillicKey) {
+            processKey(SKKCyrillicState.KEYCODE_TOGGLE_CYRILLIC)
+            return true
+        }
+
         if (engineState === SKKASCIIState && !mEngine.isRegistering) {
             return super.onKeyDown(keyCode, event)
         }
@@ -680,7 +686,7 @@ class SKKService : InputMethodService() {
         mEngine.commitTextSKK(text)
     }
     fun pickCandidateViewManually(index: Int) {
-        if (mEngine.state === SKKASCIIState) {
+        if (mEngine.state === SKKASCIIState || mEngine.state === SKKCyrillicState) {
             mQwertyInputView?.let { qwerty ->
                 mCandidateView?.let { cand ->
                     val ic = currentInputConnection ?: return
@@ -849,6 +855,7 @@ class SKKService : InputMethodService() {
         when (state) {
             SKKASCIIState -> {
                 val qwerty = mQwertyInputView ?: return
+                qwerty.setCyrillicMode(false)
                 setInputView(qwerty)
             }
             SKKHiraganaState -> {
@@ -865,6 +872,11 @@ class SKKService : InputMethodService() {
                 val abbrev = mAbbrevKeyboardView ?: return
                 setInputView(abbrev)
             }
+            SKKCyrillicState -> {
+                val qwerty = mQwertyInputView ?: return
+                qwerty.setCyrillicMode(true)
+                setInputView(qwerty)
+            }
         }
     }
 
@@ -881,6 +893,7 @@ class SKKService : InputMethodService() {
         internal const val COMMAND_SPEECH_RECOGNITION = "jp.deadend.noname.skk.COMMAND_SPEECH_RECOGNITION"
         internal const val DICT_ZIP_FILE = "skk_dict_btree_db.zip"
         internal const val FREQUENCY_LIST_FILE = "en_US_wordlist.txt"
+        internal const val CYRILLIC_FREQUENCY_LIST_FILE = "ru_wordlist.txt"
         private const val CHANNEL_ID = "skk_notification"
         private const val CHANNEL_NAME = "SKK"
     }
diff --git a/app/src/main/java/jp/deadend/noname/skk/engine/SKKASCIIState.kt b/app/src/main/java/jp/deadend/noname/skk/engine/SKKASCIIState.kt
index 8aa28ba..1df4881 100644
--- a/app/src/main/java/jp/deadend/noname/skk/engine/SKKASCIIState.kt
+++ b/app/src/main/java/jp/deadend/noname/skk/engine/SKKASCIIState.kt
@@ -8,7 +8,11 @@ object SKKASCIIState : SKKState {
     override fun handleKanaKey(context: SKKEngine) = context.changeState(SKKHiraganaState)
 
     override fun processKey(context: SKKEngine, pcode: Int) {
-        context.commitTextSKK(pcode.toChar().toString())
+        if (pcode == SKKCyrillicState.KEYCODE_TOGGLE_CYRILLIC) {
+            context.changeState(SKKCyrillicState)
+        } else {
+            context.commitTextSKK(pcode.toChar().toString())
+        }
     }
 
     override fun afterBackspace(context: SKKEngine) {}
diff --git a/app/src/main/java/jp/deadend/noname/skk/engine/SKKCyrillicState.kt b/app/src/main/java/jp/deadend/noname/skk/engine/SKKCyrillicState.kt
new file mode 100644
index 0000000..83aae11
--- /dev/null
+++ b/app/src/main/java/jp/deadend/noname/skk/engine/SKKCyrillicState.kt
@@ -0,0 +1,45 @@
+package jp.deadend.noname.skk.engine
+
+import android.os.Build
+import jp.deadend.noname.skk.R
+
+// キリル文字モード
+object SKKCyrillicState : SKKState {
+    override val isTransient = false
+    override val icon = if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
+        R.drawable.ic_cyrillic
+    } else {
+        R.drawable.immodeic_cyrillic
+    }
+    private val mCyrillicMap = mapOf(
+        'q' to "й", 'w' to "ц", 'e' to "у", 'r' to "к", 't' to "е", 'y' to "н", 'u' to "г", 'i' to "ш", 'o' to "щ", 'p' to "з", '-' to "х", '\\' to "ё",
+        'Q' to "Й", 'W' to "Ц", 'E' to "У", 'R' to "К", 'T' to "Е", 'Y' to "Н", 'U' to "Г", 'I' to "Ш", 'O' to "Щ", 'P' to "З", '=' to "Х", '_' to "Ё",
+        'a' to "ф", 's' to "ы", 'd' to "в", 'f' to "а", 'g' to "п", 'h' to "р", 'j' to "о", 'k' to "л", 'l' to "д", '/' to "ж", ':' to "ъ",
+        'A' to "Ф", 'S' to "Ы", 'D' to "В", 'F' to "А", 'G' to "П", 'H' to "Р", 'J' to "О", 'K' to "Л", 'L' to "Д", '?' to "Ж", '*' to "Ъ",
+        'z' to "я", 'x' to "ч", 'c' to "с", 'v' to "м", 'b' to "и", 'n' to "т", 'm' to "ь", ',' to "б", '.' to "ю", ']' to "э",
+        'Z' to "Я", 'X' to "Ч", 'C' to "С", 'V' to "М", 'B' to "И", 'N' to "Т", 'M' to "Ь", '<' to "Б", '>' to "Ю", '}' to "Э"
+    )
+    const val KEYCODE_TOGGLE_CYRILLIC = -1012
+
+    override fun handleKanaKey(context: SKKEngine) {
+        context.changeState(SKKHiraganaState)
+    }
+
+    override fun processKey(context: SKKEngine, pcode: Int) {
+        if (pcode == KEYCODE_TOGGLE_CYRILLIC) {
+            context.changeState(SKKASCIIState)
+            return
+        }
+
+        val cy = mCyrillicMap[pcode.toChar()]
+        if (cy != null) {
+            context.commitTextSKK(cy)
+        } else {
+            context.commitTextSKK(pcode.toChar().toString())
+        }
+    }
+
+    override fun afterBackspace(context: SKKEngine) {}
+
+    override fun handleCancel(context: SKKEngine) = false
+}
diff --git a/app/src/main/java/jp/deadend/noname/skk/engine/SKKEngine.kt b/app/src/main/java/jp/deadend/noname/skk/engine/SKKEngine.kt
index 61c353c..cbb0d27 100644
--- a/app/src/main/java/jp/deadend/noname/skk/engine/SKKEngine.kt
+++ b/app/src/main/java/jp/deadend/noname/skk/engine/SKKEngine.kt
@@ -660,6 +660,10 @@ class SKKEngine(
                 changeState(SKKAbbrevState)
                 return true
             }
+            SKKCyrillicState.KEYCODE_TOGGLE_CYRILLIC -> {
+                changeState(SKKCyrillicState)
+                return true
+            }
         }
 
         return false
diff --git a/app/src/main/java/jp/deadend/noname/skk/engine/SKKZenkakuState.kt b/app/src/main/java/jp/deadend/noname/skk/engine/SKKZenkakuState.kt
index 70f779f..a459668 100644
--- a/app/src/main/java/jp/deadend/noname/skk/engine/SKKZenkakuState.kt
+++ b/app/src/main/java/jp/deadend/noname/skk/engine/SKKZenkakuState.kt
@@ -18,7 +18,11 @@ object SKKZenkakuState : SKKState {
     }
 
     override fun processKey(context: SKKEngine, pcode: Int) {
-        context.commitTextSKK(hankaku2zenkaku(pcode).toChar().toString())
+        if (pcode == SKKCyrillicState.KEYCODE_TOGGLE_CYRILLIC) {
+            context.changeState(SKKCyrillicState)
+        } else {
+            context.commitTextSKK(hankaku2zenkaku(pcode).toChar().toString())
+        }
     }
 
     override fun afterBackspace(context: SKKEngine) {}
